//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "cnvmain.h"
#include <stdio.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
TColor ConvertCol(long col)
{
col&=0x00FFFFFF;
long bcol=col;
bcol&=0x0000FF;
bcol*=0x10000;
long rcol=col;
rcol&=0xFF0000;
rcol/=0x10000;
long gcol=col;
gcol&=0x00FF00;
TColor result=(TColor)(rcol|gcol|bcol);
return result;
};
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveClick(TObject *Sender)
{
TFileStream* fs=new TFileStream("test.xgr",fmCreate);
TVclBmp* bmp=new TVclBmp;
TColor *row;
TColor ptr;
int iptr;
int ns=sizeof(TColor);
bmp->Width=Image1->Picture->Bitmap->Width;
bmp->Height=Image1->Picture->Bitmap->Height;
TRect rect(0,0,Image1->Width,Image1->Height);
bmp->Canvas->CopyRect(rect,Image1->Picture->Bitmap->Canvas,rect);
iptr=bmp->Width;
fs->Write(&iptr,ns);
iptr=bmp->Height;
fs->Write(&iptr,ns);
Bar->Position=0;
Bar->Max=bmp->Height;
for(int i=0;i<bmp->Height;i++)
{
Bar->StepIt();
row=(TColor*)bmp->ScanLine[i];
fs->WriteBuffer(row,ns*bmp->Width);
};
delete fs;
delete bmp;
ScrollBox1Resize(0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::LoadClick(TObject *Sender)
{
TFileStream* fs=new TFileStream("test.xgr",fmOpenRead);
TVclBmp* bmp=new TVclBmp;
TColor ptr;
int ns=sizeof(TColor);
bmp->PixelFormat=pf32bit;
fs->Read(&ptr,ns);
bmp->Width=ptr;
fs->Read(&ptr,ns);
bmp->Height=ptr;
Bar->Position=0;
Bar->Max=bmp->Height;
for(int i=0;i<bmp->Height;i++)
{
Bar->StepIt();
for(int j=0;j<bmp->Width;j++)
{
fs->Read(&ptr,ns);
bmp->Canvas->Pixels[j][i]=ConvertCol(ptr);
};
};
Image2->Picture->Bitmap->Width=bmp->Width;
Image2->Picture->Bitmap->Height=bmp->Height;
Image2->Canvas->Draw(0,0,bmp);
delete fs;
delete bmp;
ScrollBox2Resize(0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::LoadFileClick(TObject *Sender)
{
if(!Open1->Execute())return;
Image1->Picture->LoadFromFile(Open1->FileName);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScrollBox1Resize(TObject *Sender)
{
if(Image1->Width<ScrollBox1->ClientRect.Width())
  Image1->Left=(ScrollBox1->ClientRect.Width()-Image1->Width)/2;
else Image1->Left=0;
if(Image1->Height<ScrollBox1->ClientRect.Height())
  Image1->Top=(ScrollBox1->ClientRect.Height()-Image1->Height)/2;
else Image1->Top=0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScrollBox2Resize(TObject *Sender)
{
if(Image2->Width<ScrollBox1->ClientRect.Width())
  Image2->Left=(ScrollBox1->ClientRect.Width()-Image2->Width)/2;
else Image2->Left=0;
if(Image2->Height<ScrollBox1->ClientRect.Height())
  Image2->Top=(ScrollBox1->ClientRect.Height()-Image2->Height)/2;
else Image2->Top=0;
}
//---------------------------------------------------------------------------
String GetError(void)
{
LPVOID lpMsgBuf;

FormatMessage(
    FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
    NULL,
    GetLastError(),
    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
    (LPTSTR) &lpMsgBuf,
    0,
    NULL
);

AnsiString err=(Char*)lpMsgBuf;
return err;
}

